# coding: utf-8

"""
    Deep Search (DS) API

    API for Deep Search.  **WARNING**: This API is subject to change without warning!

    The version of the OpenAPI document: 3.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from deepsearch.cps.apis.public_v2.models.gen_ai_watsonx import GenAIWatsonx
from deepsearch.cps.apis.public_v2.models.gen_aiaws_bedrock import GenAIAWSBedrock
from deepsearch.cps.apis.public_v2.models.gen_aibam import GenAIBAM
from deepsearch.cps.apis.public_v2.models.gen_aihf_inference_api import GenAIHFInferenceApi
from typing import Union, Any, List, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

RESPONSEGETPROJECTINTEGRATIONCONFIGGENAI_ANY_OF_SCHEMAS = ["GenAIAWSBedrock", "GenAIBAM", "GenAIHFInferenceApi", "GenAIWatsonx"]

class ResponseGetProjectIntegrationConfigGenai(BaseModel):
    """
    ResponseGetProjectIntegrationConfigGenai
    """

    # data type: GenAIBAM
    anyof_schema_1_validator: Optional[GenAIBAM] = None
    # data type: GenAIWatsonx
    anyof_schema_2_validator: Optional[GenAIWatsonx] = None
    # data type: GenAIHFInferenceApi
    anyof_schema_3_validator: Optional[GenAIHFInferenceApi] = None
    # data type: GenAIAWSBedrock
    anyof_schema_4_validator: Optional[GenAIAWSBedrock] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[GenAIAWSBedrock, GenAIBAM, GenAIHFInferenceApi, GenAIWatsonx]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: List[str] = Field(default=Literal["GenAIAWSBedrock", "GenAIBAM", "GenAIHFInferenceApi", "GenAIWatsonx"])

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = ResponseGetProjectIntegrationConfigGenai.model_construct()
        error_messages = []
        # validate data type: GenAIBAM
        if not isinstance(v, GenAIBAM):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GenAIBAM`")
        else:
            return v

        # validate data type: GenAIWatsonx
        if not isinstance(v, GenAIWatsonx):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GenAIWatsonx`")
        else:
            return v

        # validate data type: GenAIHFInferenceApi
        if not isinstance(v, GenAIHFInferenceApi):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GenAIHFInferenceApi`")
        else:
            return v

        # validate data type: GenAIAWSBedrock
        if not isinstance(v, GenAIAWSBedrock):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GenAIAWSBedrock`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in ResponseGetProjectIntegrationConfigGenai with anyOf schemas: GenAIAWSBedrock, GenAIBAM, GenAIHFInferenceApi, GenAIWatsonx. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[GenAIBAM] = None
        try:
            instance.actual_instance = GenAIBAM.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[GenAIWatsonx] = None
        try:
            instance.actual_instance = GenAIWatsonx.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[GenAIHFInferenceApi] = None
        try:
            instance.actual_instance = GenAIHFInferenceApi.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[GenAIAWSBedrock] = None
        try:
            instance.actual_instance = GenAIAWSBedrock.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ResponseGetProjectIntegrationConfigGenai with anyOf schemas: GenAIAWSBedrock, GenAIBAM, GenAIHFInferenceApi, GenAIWatsonx. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], GenAIAWSBedrock, GenAIBAM, GenAIHFInferenceApi, GenAIWatsonx]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


